<?php
/**
 * @package Module 123 Flash Chat for DatingPro2013
 * @version $Id: userdata.php  2013-08-1$
 * @author Cheney
 * @copyright (C) 2001-2013 - TOPCMM SOFTWARE
 * @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @websites http://www.123flashchat.com
 * @technical support http://www.123flashchat.com/support.html
**/
include "common_index.php";

$ACTION_QUERY = 0;
$ACTION_ADD = 1;
$ACTION_DELETE = 2;
$ACTION_UPDATE = 3;


$uinfo = getUserInfo();
$doc = new DOMDocument('1.0', 'utf-8');


if($uinfo['id'] = getUserId($uinfo['u'])){
	$action = empty($_GET['action']) ? 0 : $_GET['action'];
	$FL = $doc->createElement('FL');
	switch($action){
		case $ACTION_ADD:
			addFriends($uinfo,$doc,$FL);
		break;
		case $ACTION_DELETE:
			removeFriends($uinfo,$doc,$FL);
		break;
		case $ACTION_QUERY:
			$UD = $doc->createElement('UD');			
			getFriendsList($uinfo,$doc,$UD,$FL);
			getOpFriendlist($uinfo,$doc,$UD,$FL);
			$doc->appendChild($UD);
		break;
		case $ACTION_UPDATE:
			if($_GET['friendgroup'] == 'stranger'){
				removeFriends($uinfo,$doc,$FL);
			}else if($_GET['friendgroup'] == 'general'){
				addFriends($uinfo,$doc,$FL);
			}
		}
}

outputXml($doc);

function addFriends($uinfo,$doc,$FL){
	global  $dbconn, $topcmm_config;
	ignoreUpdate($doc,$FL);
	if($uinfo['fid'] = getUserId($uinfo['fn'])){
		if(!checkRowExists($uinfo['id'],$uinfo['fid'])){
			if(!checkRowExists($uinfo['fid'],$uinfo['id'])){
				$sql = "insert into `".$topcmm_config['hostlist_table']."` (id_user, id_friend, friend_type, date_sent) values('".$uinfo['id']."','".$uinfo['fid']."','0','".date('Y-m-d H:i:s')."')";
				$rs = $dbconn->Execute($sql);
				if($rs){
					$doc = responseSuccess($doc,$FL);
				}else{
					$doc = responseFailed($doc,$FL);
				}
			}else{
				$sql = "update `".$topcmm_config['hostlist_table']."` set accepted='1', date_accepted='".date('Y-m-d H:i:s')."' where id_user=".$uinfo['fid']." and id_friend=".$uinfo['id'];
				$dbconn->Execute($sql);				
				$sql = "insert into `".$topcmm_config['hostlist_table']."` (id_user, id_friend, friend_type, accepted, date_sent) values('".$uinfo['id']."','".$uinfo['fid']."','0','1','".date('Y-m-d H:i:s')."')";
				$dbconn->Execute($sql);
				$doc = responseSuccess($doc,$FL);
			}
		}else{
			$doc = responseSuccess($doc,$FL);
		}
	}else{
		$doc = responseFailed($doc,$FL);
	}
	return $doc;
}

function removeFriends($uinfo,$doc,$FL){
	global  $dbconn, $topcmm_config;
	ignoreUpdate($doc,$FL);
	if($uinfo['fid'] = getUserId($uinfo['fn'])){
		$sql = "delete from ".$topcmm_config['hostlist_table']." where id_user = '".$uinfo['id']."' and id_friend = '".$uinfo['fid']."'";
		$dbconn->Execute($sql);
		$sql = "delete from ".$topcmm_config['hostlist_table']." where id_user = '".$uinfo['fid']."' and id_friend = '".$uinfo['id']."'";
		$dbconn->Execute($sql);
		$doc = responseSuccess($doc,$FL);
	}else{
		$doc = responseFailed($doc,$FL);
	}
	return $doc;
}

function getFriendsList($uinfo,$doc,$UD,$FL){
	global  $dbconn, $topcmm_config;
	$uid = $uinfo['id'];
	$general = $doc->createElement("g");
	$general->setAttribute("n", "general");
	$FL->appendChild($general);
	$sql = "select u.login from ".$topcmm_config['hostlist_table']." as f, ".$topcmm_config['user_table']." as u where f.id_user='".$uid."' and f.id_friend = u.id";
	$rs = $dbconn->Execute($sql);		
	while(!$rs->EOF){
		 $u = $doc->createElement("u");
		 $u->setAttribute("n", $rs->fields[0]);
		 $general->appendChild($u);
		 $rs->MoveNext();
	}
	$UD->appendChild($FL);
	return $doc;
}



function getOpFriendlist($uinfo,$doc,$UD,$FL){
 	global  $dbconn, $topcmm_config;
 	$uid = $uinfo['id'];
 	$d = false;
	$sql = "select u.login, u.id from ".$topcmm_config['hostlist_table']." as f, ".$topcmm_config['user_table']." as u where f.id_friend='".$uid."' and f.id_user = u.id";
	$rs = $dbconn->Execute($sql);
	$general = $doc->createElement("g");
	$general->setAttribute("n", "stranger");
	while(!$rs->EOF){
		$d = true;
		$u = $doc->createElement("u");
		$u->setAttribute("n", $rs->fields[0]);
		$general->appendChild($u);
		$rs->MoveNext();
	}
	if($d)$FL->appendChild($general);
	$UD->appendChild($FL);
	return $doc;
}


function getUserInfo(){
	$username = empty($_GET['username']) ? '' : $_GET['username'];
	$destusername = empty($_GET['destusername']) ? '' : $_GET['destusername'];
	$uinfo['u'] = processName($username);
	$uinfo['fn'] = processName($destusername);
	$uinfo['p'] = isset($_GET['password']) ? $_GET['password'] : '';
	return $uinfo;
}



function processName($name){
	$name = isset($name) ? trim(htmlspecialchars($name)) : '';
	$name = substr(str_replace("\\'", "'", $name), 0, 25);
	$name = str_replace("'", "\\'", $name);
	$name = mysql_escape_string($name);
	return $name;
}

function getUserId($name){
	global  $dbconn, $topcmm_config;
	$sql = "select id from `".$topcmm_config['user_table']."` where login='".$name."'";
	$rs = $dbconn->Execute($sql);
	if($rs->fields){
		return $rs->fields[0];
	}else{
		return false;
	}
}

function checkRowExists($id,$fid){
	global  $dbconn, $topcmm_config;
	$sql = "select * from `".$topcmm_config['hostlist_table']."` where id_user = ".$id." and id_friend=".$fid;
	$rs = $dbconn->Execute($sql);
	if($rs->fields){
		return true;
	}
	return false;
}

function ignoreupdate($doc,$FL){
	if($_GET['friendgroup'] == "stranger"){
		responseSuccess($doc,$FL);
	}
}

function outputXml($doc){
		header("Content-Type: text/xml; charset=utf8");
		echo $doc->saveXml();
		exit;
}

function responseSuccess($doc,$FL){
	$FL->setAttribute("r", 0);
	$doc->appendChild($FL);
	return $doc;
}

function responseFailed($doc,$FL){
	$FL->setAttribute("r", 1);
	$doc->appendChild($FL);
	return $doc;
}

